from Products.Archetypes.public import *
from Products.CMFCore import CMFCorePermissions
import utilities
import urllib

schema = BaseSchema + Schema((
    TextField(
        name='message',
        required=0,
        searchable=0,
        default='',
	widget=TextAreaWidget(rows=20),
	accessor='render_message_as_html'
    ),
    BooleanField(
	name='mailed',
	searchable=0,
	mode='r'
    ),
))

class ELetter(BaseContent):
    """
    """

    meta_type = archetype_name = 'ELetter'
    schema = schema
    global_allow = False
    allowed_content_types = None
    message = u''
    mailed = False

    actions = (
                { 'id': 'send_email',
                  'name': 'Send email',
                  'action': 'send_email',
                  'permissions': (CMFCorePermissions.ManagePortal,),
		  'condition':'python:not here.mailed',
                },
    )

    def render_message_as_html(self):
        """Renders the message as HTML."""
	message = str(self.message)
        message = message.replace('\n', '<br />')
        message = message.replace('\r', '<br />')
        message = message.replace('\r\n', '<br />')
	return message

    def send_email(self):
        """Sends an email."""
        if self.mailed:
            self.REQUEST.RESPONSE.redirect(self.absolute_url() + \
		'portal_status_message=This+letter+has+already+been+mailed.')
            return
        failed = utilities.send_email(self, mailing_list=self.mailing_list)
        self.mailed = True
        message = "Letter mailed."
        if failed:
            message += " Failed for " + ','.join(failed) + '.'
        message = urllib.quote(message)
        self.REQUEST.RESPONSE.redirect(
		self.absolute_url() + '?portal_status_message=' + message
	)

registerType(ELetter)
